////////////////////////////////////////////////////////////////////////////////////////
// File: scripts/lib/utility.js
// Usage: utility functions
////////////////////////////////////////////////////////////////////////////////////////

import { world } from "@minecraft/server";

////////////////////////////////////////////////////////////////////////////////////////

export function getForwardVector(player) {
  const rotation = player.getRotation();
  const yawRadians = (rotation.y * Math.PI) / 180;
  const forwardVector = {  x: -Math.sin(yawRadians) * 3, y: 0, z: Math.cos(yawRadians) * 3, };
  return forwardVector
}

////////////////////////////////////////////////////////////////////////////////////////

export function generateUniqueID() {
  return Math.floor(Math.random() * 1000000).toString(); // Simple unique ID generation
}

////////////////////////////////////////////////////////////////////////////////////////

export function markRespawned(player) {
  const health = player.getComponent("health");
  health.currentValue == 0 ? player.setDynamicProperty("isDead", true) : player.setDynamicProperty("isDead", false);
  player.getDynamicProperty("isDead") == true;
  return;
}

////////////////////////////////////////////////////////////////////////////////////////

export function isInvulnerable(target) {
  const gamemode = target.getGameMode();
  return gamemode === "creative" || gamemode === "spectator";
}

////////////////////////////////////////////////////////////////////////////////////////

export function addVector(v1, v2) {
  return { x: v1.x + v2.x, y: v1.y + v2.y, z: v1.z + v2.z};
}

////////////////////////////////////////////////////////////////////////////////////////

export function constrain(value, min, max) {
  if (value < min) return min;
  if (value > max) return max;
  return value;
}

////////////////////////////////////////////////////////////////////////////////////////

export function getOrCreateScoreboard(id) {
  return world.scoreboard.getObjective(id) || world.scoreboard.addObjective(id);
}

////////////////////////////////////////////////////////////////////////////////////////

export const lerp = function (start, end, lerp) {
  return start + (end - start) * lerp;
};

////////////////////////////////////////////////////////////////////////////////////////
