
////////////////////////////////////////////////////////////////////////////////////////

export function playerStunHandler(player) {
  const stunned = player.getDynamicProperty("sbs_mib:player_stunned") || 0;
  if (stunned > 0) {
    if (player.inputPermissions.movementEnabled) {
      player.inputPermissions.movementEnabled = false;
    }
    player.setDynamicProperty("sbs_mib:player_stunned", stunned - 1);
  } else if (!player.inputPermissions.movementEnabled) {
    player.inputPermissions.movementEnabled = true;
  }
}

////////////////////////////////////////////////////////////////////////////////////////

export function stunEventHandler(event) {
  const sec = event.message || 1;
  try {
    event.sourceEntity.setDynamicProperty("sbs_mib:player_stunned", sec * 20);
  } catch {
    console.log(`ERROR: Could not stun player: ${event.sourceEntity.name}`);
  }
}

////////////////////////////////////////////////////////////////////////////////////////

export function stunPlayer(player, sec) {
  try {
    player.setDynamicProperty("sbs_mib:player_stunned", sec * 20);
  } catch {
    console.log(`ERROR: Could not stun player: ${player.name}`);
  }
}

////////////////////////////////////////////////////////////////////////////////////////