// UTILITY THINGS

//Custom square function for code readability
export const sqr = function (num) {
  return num * num;
};

// Custom distance function for determining the distance between two vectors (entities, blocks, etc)
export const distance3D = function (v1, v2) {
  return Math.sqrt(sqr(v1.x - v2.x) + sqr(v1.y - v2.y) + sqr(v1.z - v2.z));
};

export const distance3D2 = function (v1, v2) {
  return Math.sqrt(sqr(v1.x - v2.x) + sqr(v1.y - v2.y) + sqr(v1.z - v2.z));
};

export const distance3D3 = function (v1, v2) {
  return Math.sqrt(sqr(v1.x - v2.x) + sqr(v1.y - v2.y) + sqr(v1.z - v2.z));
};
// Generate a 3D vector from 2 provided angles
export const vector3FromAngles = function (alpha, beta) {
  let x = Math.cos(alpha) * Math.cos(beta);
  let z = Math.sin(alpha) * Math.cos(beta);
  let y = Math.sin(beta);
  return { x, y, z };
};

// Subtracts one vector from another; essentially returns a vector that points from one vector to the other
export const subtractVectors = function (v1, v2) {
  return { x: v1.x - v2.x, y: v1.y - v2.y, z: v1.z - v2.z };
};

// Multiplies the vector by the number
export const multiplyVector = function (vector, number) {
  return { x: vector.x * number, y: vector.y * number, z: vector.z * number };
};

// Divides the vector by the number
export const divideVector = function (vector, number) {
  return { x: vector.x / number, y: vector.y / number, z: vector.z / number };
};
export const scanConfigurations = [
	{ minRadius: 1, maxRadius: 2, delay: 0 },
	{ minRadius: 3, maxRadius: 4, delay: 0.5 },
	{ minRadius: 5, maxRadius: 6, delay: 1 },
	{ minRadius: 7, maxRadius: 8, delay: 2 },
	{ minRadius: 9, maxRadius: 10, delay: 3 },
	{ minRadius: 11, maxRadius: 12, delay: 4 },
	{ minRadius: 13, maxRadius: 14, delay: 5 },
];
export const oreList = [
	"minecraft:iron_ore",
	"minecraft:gold_ore",
  "minecraft:diamond_ore",
  "minecraft:lapis_ore",
  "minecraft:redstone_ore",
  "minecraft:lit_redstone_ore",
  "minecraft:coal_ore",
  "minecraft:copper_ore",
  "minecraft:emerald_ore",
  "minecraft:quartz_ore",
  "minecraft:nether_gold_ore",
  "minecraft:deepslate_iron_ore",
  "minecraft:deepslate_gold_ore",
  "minecraft:deepslate_diamond_ore",
  "minecraft:deepslate_lapis_ore",
  "minecraft:deepslate_redstone_ore",
  "minecraft:lit_deepslate_redstone_ore",
  "minecraft:deepslate_coal_ore",
  "minecraft:deepslate_copper_ore",
  "minecraft:deepslate_emerald_ore",
];
export const itemIdentifierList = {
	allay_bottle_item : "minecraft:allay",
	armadillo_bottle_item : "minecraft:armadillo",
	axolotl_bottle_item : "minecraft:axolotl",
	bat_bottle : "minecraft:bat",
	bee_bottle_item : "minecraft:bee",
	blaze_bottle_item : "minecraft:blaze",
	bogged_bottle_item : "minecraft:bogged",
	breeze_bottle_item : "minecraft:breeze",
	camel_bottle_item : "minecraft:camel",
	cat_bottle_item : "minecraft:cat",
	ocelot_bottle: "minecraft:ocelot",
	cave_spider_bottle_item : "minecraft:cave_spider",
	chicken_bottle_item : "minecraft:chicken",
	cod_bottle_item : "minecraft:cod",
	cow_bottle_item : "minecraft:cow",
	mooshroom_bottle : "minecraft:mooshroom",
	creeper_bottle_item : "minecraft:creeper",
	creaking_bottle :"minecraft:creaking",
	dolphin_bottle_item : "minecraft:dolphin",
	donkey_bottle_item : "minecraft:donkey",
	elder_guardian_bottle_item : "minecraft:elder_guardian",
	enderman_bottle_item : "minecraft:enderman",
	endermite_bottle_item : "minecraft:endermite",
	ender_dragon_bottle : "minecraft:ender_dragon",
	ender_dragon_bottle : "sbs_mib:ender_dragon_pet",
	evocator_bottle_item : "minecraft:evocation_illager",
	fox_bottle_item : "minecraft:fox",
	frog_bottle_item : "minecraft:frog",
	ghast_bottle_item : "minecraft:ghast",
	glow_squid_bottle_item : "minecraft:glow_squid",
	goat_bottle_item : "minecraft:goat",
	guardian_bottle_item : "minecraft:guardian",
	hoglin_bottle_item : "minecraft:hoglin",
	horse_bottle_item : "minecraft:horse",
	llama_bottle_item : "minecraft:llama",
	magma_cube_bottle_item : "minecraft:magma_cube",
	mule_bottle_item : "minecraft:mule",
	panda_bottle_item : "minecraft:panda",
	parrot_bottle_item : "minecraft:parrot",
	phantom_bottle_item : "minecraft:phantom",
	pig_bottle_item : "minecraft:pig",
	piglin_bottle_item : "minecraft:piglin",
	piglin_brute_bottle : "minecraft:piglin_brute",
	pillager_bottle_item : "minecraft:pillager",
	polar_bear_bottle_item : "minecraft:polar_bear",
	pufferfish_bottle_item : "minecraft:pufferfish",
	rabbit_bottle_item : "minecraft:rabbit",
	ravager_bottle_item : "minecraft:ravager",
	sheep_bottle_item : "minecraft:sheep",
	shulker_bottle_item : "minecraft:shulker",
	skeleton_bottle_item : "minecraft:skeleton",
	skeleton_horse_bottle : "minecraft:skeleton_horse",
	slime_bottle_item : "minecraft:slime",
	silverfish_bottle_item : "minecraft:silverfish",
	sniffer_bottle_item : "minecraft:sniffer",
	snow_golem_bottle_item : "minecraft:snow_golem",
	spider_bottle_item : "minecraft:spider",
	squid_bottle_item : "minecraft:squid",
	stray_bottle_item : "minecraft:stray",
	strider_bottle_item : "minecraft:strider",
	turtle_bottle_item : "minecraft:turtle",
	vex_bottle_item : "minecraft:vex",
	villager_bottle_item : "minecraft:villager",
	vindicator_bottle_item : "minecraft:vindicator",
	wandering_trader_bottle_item : "minecraft:wandering_trader",
	warden_bottle_item : "minecraft:warden",
	witch_bottle_item : "minecraft:witch",
	wither_bottle_item : "minecraft:wither",
	wither_skeleton_bottle_item : "minecraft:wither_skeleton",
	wolf_bottle_item : "minecraft:wolf",
	zombie_bottle_item : "minecraft:zombie",
	husk_bottle: "minecraft:husk",
	drowned_bottle: "minecraft:drowned",
	zombie_horse_bottle_item : "minecraft:zombie_horse",
	zombified_piglin_bottle_item : "minecraft:zombie_pigman"
};
export const itemNameList = [
	"Zombie Bottle",
	"Husk Bottle",
	"Donkey Bottle",
	"Mule Bottle",
	"Skeleton Bottle",
	"Axolotl Bottle",
	"Fish Bottle",
	"Cow Bottle",
	"Mooshroom Bottle",
	"Snow Golem Bottle",
	"Strider Bottle",
	"Pig Bottle",
	"Phantom Bottle",
	"Horse Bottle",
	"Skeleton Horse Bottle",
	"Zombie Horse Bottle",
	"Polar Bear Bottle",
	"Stray Bottle",
	"Cat Bottle",
	"Ocelot",
	"Fox Bottle",
	"Piglin Bottle",
	"Piglin Brute Bottle",
	"Hoglin Bottle",
	"Creeper Bottle",
	"Creaking",
	"Allay Bottle",
	"Shulker Bottle",
	"Enderman Bottle",
	"Endermite Bottle",
	"Ender Dragon",
	"Ender Dragon Pet",
	"Bee Bottle",
	"Wither Bottle",
	"Chicken Bottle",
	"Pufferfish Bottle",
	"Sheep Bottle",
	"Wolf Bottle",
	"Llama Bottle",
	"Bat Bottle",
	"Squid Bottle",
	"Glow Squid Bottle",
	"Frog Bottle",
	"Rabbit Bottle",
	"Wandering Trader Bottle",
	"Villager Bottle",
	"Parrot Bottle",
	"Turtle Bottle",
	"Goat Bottle",
	"Dolphin Bottle",
	"Panda Bottle",
	"Zombified Piglin Bottle",
	"Warden Bottle",
	"Silverfish Bottle",
	"Spider Bottle",
	"Cave Spider Bottle",
	"Blaze Bottle",
	"Guardian Bottle",
	"Magma Cube Bottle",
	"Evocator Bottle",
	"Vex Bottle",
	"Elder Guardian Bottle",
	"Ghast Bottle",
	"Pillager Bottle",
	"Ravager Bottle",
	"Slime Bottle",
	"Witch Bottle",
	"Vindicator Bottle",
	"Wither Skeleton Bottle",
	"Bogged Bottle",
	"Breeze Bottle",
	"Sniffer Bottle",
	"Camel Bottle",
	"Armadillo Bottle"
];
export const itemIDList = [
	"minecraft:zombie",
	"minecraft:husk",
	"minecraft:donkey",
	"minecraft:mule",
	"minecraft:skeleton",
	"minecraft:axolotl",
	"minecraft:cod",
	"minecraft:cow",
	"minecraft:mooshroom",
	"minecraft:snow_golem",
	"minecraft:strider",
	"minecraft:pig",
	"minecraft:phantom",
	"minecraft:horse",
	"minecraft:skeleton_horse",
	"minecraft:zombie_horse",
	"minecraft:polar_bear",
	"minecraft:stray",
	"minecraft:cat",
	"minecraft:ocelot",
	"minecraft:fox",
	"minecraft:piglin",
	"minecraft:piglin_brute",
	"minecraft:hoglin",
	"minecraft:creeper",
	"minecraft:creaking",
	"minecraft:allay",
	"minecraft:shulker",
	"minecraft:enderman",
	"minecraft:endermite",
	"minecraft:ender_dragon",
	"sbs_mib:ender_dragon_pet",
	"minecraft:bee",
	"minecraft:wither",
	"minecraft:chicken",
	"minecraft:pufferfish",
	"minecraft:sheep",
	"minecraft:wolf",
	"minecraft:llama",
	"minecraft:bat",
	"minecraft:squid",
	"minecraft:glow_squid",
	"minecraft:frog",
	"minecraft:rabbit",
	"minecraft:wandering_trader",
	"minecraft:villager",
	"minecraft:parrot",
	"minecraft:turtle",
	"minecraft:goat",
	"minecraft:dolphin",
	"minecraft:panda",
	"minecraft:zombie_pigman",
	"minecraft:warden",
	"minecraft:silverfish",
	"minecraft:spider",
	"minecraft:cave_spider",
	"minecraft:blaze",
	"minecraft:guardian",
	"minecraft:magma_cube",
	"minecraft:evocation_illager",
	"minecraft:vex",
	"minecraft:elder_guardian",
	"minecraft:ghast",
	"minecraft:pillager",
	"minecraft:ravager",
	"minecraft:slime",
	"minecraft:witch",
	"minecraft:vindicator",
	"minecraft:wither_skeleton",
	"minecraft:bogged",
	"minecraft:breeze",
	"minecraft:sniffer",
	"minecraft:camel",
	"minecraft:armadillo"
];
export const entityList = [
	"minecraft:zombie",
	"minecraft:drowned",
	"minecraft:husk",
	"minecraft:zombie_villager",
	"minecraft:zombie_villager_v2",
	"minecraft:donkey",
	"minecraft:mule",
	"minecraft:skeleton",
	"minecraft:axolotl",
	"minecraft:cod",
	"minecraft:salmon",
	"minecraft:tropicalfish",
	"minecraft:cow",
	"minecraft:mooshroom",
	"minecraft:snow_golem",
	"minecraft:strider",
	"minecraft:pig",
	"minecraft:phantom",
	"minecraft:horse",
	"minecraft:skeleton_horse",
	"minecraft:zombie_horse",
	"minecraft:polar_bear",
	"minecraft:stray",
	"minecraft:cat",
	"minecraft:ocelot",
	"minecraft:fox",
	"minecraft:piglin",
	"minecraft:piglin_brute",
	"minecraft:hoglin",
	"minecraft:zoglin",
	"minecraft:creeper",
	"minecraft:allay",
	"minecraft:shulker",
	"minecraft:enderman",
	"minecraft:endermite",
	"minecraft:ender_dragon",
	"sbs_mib:ender_dragon_pet",
	"minecraft:bee",
	"minecraft:wither",
	"minecraft:chicken",
	"minecraft:pufferfish",
	"minecraft:sheep",
	"minecraft:wolf",
	"minecraft:llama",
	"minecraft:trader_llama",
	"minecraft:bat",
	"minecraft:squid",
	"minecraft:glow_squid",
	"minecraft:frog",
	"minecraft:rabbit",
	"minecraft:wandering_trader",
	"minecraft:villager",
	"minecraft:villager_v2",
	"minecraft:parrot",
	"minecraft:turtle",
	"minecraft:goat",
	"minecraft:dolphin",
	"minecraft:panda",
	"minecraft:zombie_pigman",
	"minecraft:warden",
	"minecraft:silverfish",
	"minecraft:spider",
	"minecraft:cave_spider",
	"minecraft:blaze",
	"minecraft:guardian",
	"minecraft:magma_cube",
	"minecraft:evocation_illager",
	"minecraft:vex",
	"minecraft:elder_guardian",
	"minecraft:ghast",
	"minecraft:pillager",
	"minecraft:ravager",
	"minecraft:slime",
	"minecraft:witch",
	"minecraft:vindicator",
	"minecraft:wither_skeleton",
	"minecraft:bogged",
	"minecraft:breeze",
	"minecraft:sniffer",
	"minecraft:camel",
	"minecraft:armadillo"
];
export const zombieTransformList = {
	slime : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	cat : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	fox : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	axolotl : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	cod : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	creaking : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	salmon : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	tropicalfish : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	bee : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	allay : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	shulker : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	chicken : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	pufferfish : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	bat : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	frog : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	rabbit : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	parrot : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	turtle : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	silverfish : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	phantom : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	vex : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	cave_spider : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	sender_dragon_pet : "zombie ~ ~ ~ ~ ~ minecraft:as_baby",
	drowned : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	husk : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	skeleton : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	stray : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	creeper : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	enderman : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	endermite : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	wither : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	iron_golem : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	evocation_illager : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	elder_guardian : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	ender_dragon : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	pillager : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	snow_man : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	vindication_illager : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	snow_golem : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	wither_skeleton : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	squid : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	glow_squid : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	dolphin : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	ghast : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	witch : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	ravager : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	sniffer : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	cow : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	mooshroom : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	strider : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	polar_bear : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	sheep : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	wolf : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	llama : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	goat : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	guardian : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	magma_cube : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	hoglin : "zoglin ~ ~ ~ ",
	piglin : "zombie_pigman ~ ~ ~",
	piglin_brute : "zombie_pigman ~ ~ ~",
	pig : "zombie_pigman ~ ~ ~ ",
	panda : "zombie_pigman ~ ~ ~ ",
	warden : "zombie_pigman ~ ~ ~ ",
	spider : "zombie_pigman ~ ~ ~ ",
	blaze : "zombie_pigman ~ ~ ~ ",
	trader_lama : "zoglin ~ ~ ~ ",
	lama : "zoglin ~ ~ ~ ",
	donkey : "zombie_horse ~ ~ ~ ",
	mule : "zombie_horse ~ ~ ~ ",
	horse : "zombie_horse ~ ~ ~ ",
	skeleton_horse : "zombie_horse ~ ~ ~ ",
	wandering_trader : "zombie_villager ~ ~ ~ ",
	villager : "zombie_villager ~ ~ ~ ",
	villager_v2 : "zombie_villager ~ ~ ~ ",
	bogged : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	breeze : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	sniffer : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	camel : "zombie ~ ~ ~ ~ ~ minecraft:as_adult",
	armadillo : "zombie ~ ~ ~ ~ ~ minecraft:as_baby"
}
export const hillPostion = [
	{ radius: 1, yOffset: 0, delayMultiplier: 0.05 },
	{ radius: 2, yOffset: -1, delayMultiplier: 0.15 },
	{ radius: 3, yOffset: -1, delayMultiplier: 0.25 },
	{ radius: 4, yOffset: -2, delayMultiplier: 0.35 },
	{ radius: 5, yOffset: -2, delayMultiplier: 0.45 },
	{ radius: 6, yOffset: -3, delayMultiplier: 0.55 },
	{ radius: 7, yOffset: -4, delayMultiplier: 0.65 },
	{ radius: 8, yOffset: -4, delayMultiplier: 0.75 }
];