import * as mc from "@minecraft/server";
import {oreList} from "./utility";

const scansInProgress = {};
export async function scanForOres(player, radius) {
  if (!scansInProgress[player.id]) {
    scansInProgress[player.id] = true;
    mc.system.runTimeout(() => {
      scanQ11(player, radius);
    }, 0);
    mc.system.runTimeout(() => {
      scanQ12(player, radius);
    }, 5);
    mc.system.runTimeout(() => {
      scanQ21(player, radius);
    }, 10);
    mc.system.runTimeout(() => {
      scanQ22(player, radius);
    }, 15);
    mc.system.runTimeout(() => {
      scanQ31(player, radius);
    }, 20);
    mc.system.runTimeout(() => {
      scanQ32(player, radius);
    }, 25);
    mc.system.runTimeout(() => {
      scanQ41(player, radius);
    }, 30);
    mc.system.runTimeout(() => {
      scanQ42(player, radius);
    }, 35);
  }
}



function scanQ11(player, radius) {
  const center = player.location;

  for (let i = 0; i <= radius; i++) {
    for (let j = 0; j <= radius; j++) {
      for (let k = 0; k <= radius; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ12(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = 0; i <= radius; i++) {
    for (let j = -radius; j <= -1; j++) {
      for (let k = 0; k <= radius; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ21(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = -radius; i <= -1; i++) {
    for (let j = 0; j <= radius; j++) {
      for (let k = 0; k <= radius; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ22(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = -radius; i <= -1; i++) {
    for (let j = -radius; j <= -1; j++) {
      for (let k = 0; k <= radius; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ31(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = 0; i <= radius; i++) {
    for (let j = 0; j <= radius; j++) {
      for (let k = -radius; k <= -1; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ32(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = 0; i <= radius; i++) {
    for (let j = -radius; j <= -1; j++) {
      for (let k = -radius; k <= -1; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ41(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = -radius; i <= -1; i++) {
    for (let j = 0; j <= radius; j++) {
      for (let k = -radius; k <= -1; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }
}

function scanQ42(player, radius) {
  const center = player.location;
  center.x += 0.5;
  center.y += 0.5;

  for (let i = -radius; i <= -1; i++) {
    for (let j = -radius; j <= -1; j++) {
      for (let k = -radius; k <= -1; k++) {
        if (center.y + k <= -64 || center.y + k > 319) return;
  let block = player.dimension.getBlock({ x: center.x + i, y: center.y + k, z: center.z + j });
  if (
    block &&
    block.isValid() && oreList.includes(block.typeId)
  ) {
    let loc = { x: block.x + 0.5, y: block.y, z: block.z + 0.5 };
    const prevXray = block.dimension.getEntities({
      location: loc,
      type: `sbs_mib:sniffer_utility`,
      closest: 1,
      maxDistance: 0.5,
    })[0];
    let event = "sbs_mib:" + block.typeId.split(":")[1];
    if (!prevXray) {
      player.runCommand(`summon sbs_mib:sniffer_utility ${block.x} ${block.y} ${block.z} 90 0 ${event}`);
    }
  }
      }
    }
  }

  delete scansInProgress[player.id];
}
